from decimal import Decimal

import ijson


class Reader:
    def __init__(self, source):
        self.objects = ijson.items(source, "data.item")

    def read(self):
        for dic in self.objects:

            for k, v in dic.items():
                # scan the result to cast all decimals into float...
                # because XMLRPC-LIB cannot send Decimal
                if isinstance(v, Decimal):
                    dic[k] = float(v)
            yield dic
